//an example based on nodenodenode
//# npm install nodenodenode moment-timezone q_sqlite3
//node -e "console.log(require('nodenodenode')({q_sqlite3:require('./q_sqlite3')}))" /server_id=db_writter /http_port=3456 /debug=1 /logic=eg_db_writter.js /approot=$APPROOT $*

module.exports=function(Application){
	const {
		Q,logger,server_id,argo
	}=Application;

	var {q_sqlite3}=argo;
	if(!q_sqlite3) q_sqlite3=require('q_sqlite3');

	var dbwrapper_a={};

	function Quit_Promise(exit_code){
		var wait_time=(exit_code>0)?exit_code:10;
		var rt={
			STS:"OK",
			errmsg:`Will Quit Server(${server_id}) after 1 sec, please try reconnect later about ${wait_time} seconds for init.`
		};
		setTimeout(()=>{
			Application.quit(exit_code);
		},111);
		return Q(rt);
	}

	function get_db(db_name){
		if(!db_name) db_name='default';
		var dbwrapper=dbwrapper_a[db_name];
		if(!dbwrapper){
			dbwrapper_a[db_name] = dbwrapper = q_sqlite3('./'+db_name+'.db');
			if(argo.WAL){
				dbwrapper.exec("PRAGMA journal_mode = WAL");//FOR BETTER CONFLICT-SOLVING.
			}
		}
		return dbwrapper;
	}

	var logic={
		__filename
		,exec_q(p){
			var STS='KO';
			var {table,toUpdate,toFind,insert_first,db,sql}=p;
			if (!sql) return Q({STS,errmsg:'.sql?'});
			var dbwrapper=get_db(db);

			return dbwrapper.exec_q(sql)
				.fail(err=>{
					if (err){
						if(err.code=='SQLITE_READONLY'){
							logger.log("\n\nSQLITE_READONLY, suggest try quit...??\n\n");
						}else{
							logger.log("\n\n",err,sql,"\n\n");
							//process.exit(1);
						}
					}
					return err;
				})
		}
		,FindAndUpsert_q(p){
			var STS='KO';
			var {table,toUpdate,toFind,insert_first,db}=p;
			var dbwrapper=get_db(db);

			return dbwrapper.FindAndUpsert_q(table,toUpdate,toFind,insert_first)
				.fail(err=>{
					if (err){
						if(err.code=='SQLITE_READONLY'){
							logger.log("\n\nSQLITE_READONLY, suggest try quit...??\n\n");
						}else{
							logger.log("\n\n",err,toUpdate,toFind,"\n\n");
						}
					}
					return err;
				})
		}
		,handleSIGINT(){
			Quit_Promise(1).done(()=>{
				logger.log('Quit for SIGINT/ctrl-c');
			});
		}
		,handleUncaughtException(err){
			logger.log('handleUncaughtException',err)
		}
	}
	//alias for old version
	logic.exec_Promise = logic.exec_q;
	logic.FindAndUpsert_Promise = logic.FindAndUpsert_q;
	return logic
}
